Park Ju Hyung | 87cdc9d | 2019-05-21 18:03:05 +0900 | [diff] [blame^] | 1 | #! /bin/sh |
| 2 | |
| 3 | # Add a .gdb_index section to a file. |
| 4 | |
| 5 | # Copyright (C) 2010-2019 Free Software Foundation, Inc. |
| 6 | # This program is free software; you can redistribute it and/or modify |
| 7 | # it under the terms of the GNU General Public License as published by |
| 8 | # the Free Software Foundation; either version 3 of the License, or |
| 9 | # (at your option) any later version. |
| 10 | # |
| 11 | # This program is distributed in the hope that it will be useful, |
| 12 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 13 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 14 | # GNU General Public License for more details. |
| 15 | # |
| 16 | # You should have received a copy of the GNU General Public License |
| 17 | # along with this program. If not, see <http://www.gnu.org/licenses/>. |
| 18 | |
| 19 | # This program assumes gdb and objcopy are in $PATH. |
| 20 | # If not, or you want others, pass the following in the environment |
| 21 | GDB=${GDB:=gdb} |
| 22 | OBJCOPY=${OBJCOPY:=objcopy} |
| 23 | |
| 24 | myname="${0##*/}" |
| 25 | |
| 26 | dwarf5="" |
| 27 | if [ "$1" = "-dwarf-5" ]; then |
| 28 | dwarf5="$1" |
| 29 | shift |
| 30 | fi |
| 31 | |
| 32 | if test $# != 1; then |
| 33 | echo "usage: $myname [-dwarf-5] FILE" 1>&2 |
| 34 | exit 1 |
| 35 | fi |
| 36 | |
| 37 | file="$1" |
| 38 | |
| 39 | if test ! -r "$file"; then |
| 40 | echo "$myname: unable to access: $file" 1>&2 |
| 41 | exit 1 |
| 42 | fi |
| 43 | |
| 44 | dir="${file%/*}" |
| 45 | test "$dir" = "$file" && dir="." |
| 46 | index4="${file}.gdb-index" |
| 47 | index5="${file}.debug_names" |
| 48 | debugstr="${file}.debug_str" |
| 49 | debugstrmerge="${file}.debug_str.merge" |
| 50 | debugstrerr="${file}.debug_str.err" |
| 51 | |
| 52 | rm -f $index4 $index5 $debugstr $debugstrmerge $debugstrerr |
| 53 | # Ensure intermediate index file is removed when we exit. |
| 54 | trap "rm -f $index4 $index5 $debugstr $debugstrmerge $debugstrerr" 0 |
| 55 | |
| 56 | $GDB --batch -nx -iex 'set auto-load no' \ |
| 57 | -ex "file $file" -ex "save gdb-index $dwarf5 $dir" || { |
| 58 | # Just in case. |
| 59 | status=$? |
| 60 | echo "$myname: gdb error generating index for $file" 1>&2 |
| 61 | exit $status |
| 62 | } |
| 63 | |
| 64 | # In some situations gdb can exit without creating an index. This is |
| 65 | # not an error. |
| 66 | # E.g., if $file is stripped. This behaviour is akin to stripping an |
| 67 | # already stripped binary, it's a no-op. |
| 68 | status=0 |
| 69 | |
| 70 | if test -f "$index4" -a -f "$index5"; then |
| 71 | echo "$myname: Both index types were created for $file" 1>&2 |
| 72 | status=1 |
| 73 | elif test -f "$index4" -o -f "$index5"; then |
| 74 | if test -f "$index4"; then |
| 75 | index="$index4" |
| 76 | section=".gdb_index" |
| 77 | else |
| 78 | index="$index5" |
| 79 | section=".debug_names" |
| 80 | fi |
| 81 | debugstradd=false |
| 82 | debugstrupdate=false |
| 83 | if test -s "$debugstr"; then |
| 84 | if ! $OBJCOPY --dump-section .debug_str="$debugstrmerge" "$file" /dev/null \ |
| 85 | 2>$debugstrerr; then |
| 86 | cat >&2 $debugstrerr |
| 87 | exit 1 |
| 88 | fi |
| 89 | if grep -q "can't dump section '.debug_str' - it does not exist" \ |
| 90 | $debugstrerr; then |
| 91 | debugstradd=true |
| 92 | else |
| 93 | debugstrupdate=true |
| 94 | cat >&2 $debugstrerr |
| 95 | fi |
| 96 | cat "$debugstr" >>"$debugstrmerge" |
| 97 | fi |
| 98 | |
| 99 | $OBJCOPY --add-section $section="$index" \ |
| 100 | --set-section-flags $section=readonly \ |
| 101 | $(if $debugstradd; then \ |
| 102 | echo --add-section .debug_str="$debugstrmerge"; \ |
| 103 | echo --set-section-flags .debug_str=readonly; \ |
| 104 | fi; \ |
| 105 | if $debugstrupdate; then \ |
| 106 | echo --update-section .debug_str="$debugstrmerge"; \ |
| 107 | fi) \ |
| 108 | "$file" "$file" |
| 109 | |
| 110 | status=$? |
| 111 | else |
| 112 | echo "$myname: No index was created for $file" 1>&2 |
| 113 | echo "$myname: [Was there no debuginfo? Was there already an index?]" 1>&2 |
| 114 | fi |
| 115 | |
| 116 | exit $status |